///////////////////////////////////////////////////////////////////////////////
// File: EchoServerMultiInstancePerfCountersDLL.cpp
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/Admin/Admin.h"

#include "EchoServerServicePerfCountersDLL.h"
#include "PerformanceDataCollector.h"
#include "PerfCountersApplicationName.h"

#include "JetByteTools/CoreTools/Exception.h"

#include "JetByteTools/Win32Tools/SEHException.h"

#pragma hdrstop

///////////////////////////////////////////////////////////////////////////////
// Using directives
///////////////////////////////////////////////////////////////////////////////

using JetByteTools::Core::_tstring;
using JetByteTools::Core::CException;

using JetByteTools::Win32::CSEHException;

using JetByteTools::PerfMon::ICollectPerformanceData;

///////////////////////////////////////////////////////////////////////////////
// User supplied function to create data collector class
///////////////////////////////////////////////////////////////////////////////

ICollectPerformanceData *CreatePerformanceDataCollector()
{
   CSEHException::Translator sehTranslator(0);

   try
   {
      return new CPerformanceDataCollector(s_applicationName);
   }
   catch(CException &e)
   {
      const _tstring message = _T("CreatePerformanceDataCollector() -  Exception: ") + e.GetDetails();

      OutputDebugString(message.c_str());
   }
   catch(...)
   {
      OutputDebugString(_T("CreatePerformanceDataCollector() - Unexpected exception"));
   }

   return nullptr;
}

///////////////////////////////////////////////////////////////////////////////
// End of file: EchoServerMultiInstancePerfCountersDLL.cpp
///////////////////////////////////////////////////////////////////////////////
